package org.glassfish.bugs;

import javax.naming.NamingException;
import javax.naming.Reference;
import javax.naming.Referenceable;
import javax.resource.ResourceException;
import javax.resource.spi.ConnectionManager;

/**
 * @author cj91
 * 
 */
public class MyJCAConnectionFactoryImpl implements MyJCAConnectionFactory, Referenceable {

	private Reference reference;
	private ConnectionManager connectionManager;
	private MyJCAManagedConnectionFactory myJCAManagedConnectionFactory;

	public MyJCAConnectionFactoryImpl(MyJCAManagedConnectionFactory myJCAManagedConnectionFactory,
		ConnectionManager cxManager) {
		this.connectionManager = cxManager;
		this.myJCAManagedConnectionFactory = myJCAManagedConnectionFactory;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public MyJCAConnection getConnection() {
		try {
			MyJCAConnection client =
				(MyJCAConnection) connectionManager.allocateConnection(myJCAManagedConnectionFactory, null);
			return client;
		} catch (ResourceException e) {
			throw new RuntimeException(e);
		}
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Reference getReference() throws NamingException {
		return reference;
	}

	/**
	 * @param reference
	 *            the reference to set
	 */
	public void setReference(Reference reference) {
		this.reference = reference;
	}
}
