package org.glassfish.bugs;

import java.io.PrintWriter;
import java.util.Set;

import javax.resource.ResourceException;
import javax.resource.spi.ConnectionManager;
import javax.resource.spi.ConnectionRequestInfo;
import javax.resource.spi.ManagedConnection;
import javax.resource.spi.ManagedConnectionFactory;
import javax.security.auth.Subject;

/**
 * @author cj91
 * 
 */
public class MyJCAManagedConnectionFactory implements ManagedConnectionFactory {
	private static final long serialVersionUID = 5L;

	private transient PrintWriter logWriter;

	/**
	 * {@inheritDoc}
	 */
	@Override
	public MyJCAConnectionFactoryImpl createConnectionFactory(ConnectionManager cxManager) throws ResourceException {
		return new MyJCAConnectionFactoryImpl(this, cxManager);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public MyJCAConnectionFactoryImpl createConnectionFactory() throws ResourceException {
		return new MyJCAConnectionFactoryImpl(this, null);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public ManagedConnection createManagedConnection(Subject subject, ConnectionRequestInfo cxRequestInfo)
		throws ResourceException {
		return new MyJCAManagedConnection(subject, cxRequestInfo);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	@SuppressWarnings("rawtypes")
	public ManagedConnection matchManagedConnections(Set connectionSet, Subject subject,
		ConnectionRequestInfo cxRequestInfo) throws ResourceException {
		if (connectionSet.size() == 0) {
			return null;
		}

		for (Object obj : connectionSet) {
			MyJCAManagedConnection con = (MyJCAManagedConnection) obj;
			if (cxRequestInfo == con.cxRequestInfo
				|| (cxRequestInfo != null && cxRequestInfo.equals(con.cxRequestInfo))) {
				return con;
			}
		}
		return null;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void setLogWriter(PrintWriter out) throws ResourceException {
		this.logWriter = out;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public PrintWriter getLogWriter() throws ResourceException {
		return logWriter;
	}
}
